上一页 1 2 3 4 5 6 7 8 ··· 19 下一页
摘要: blog。 显然答案为 \(0\) 不行。打表发现最优答案总为 \(1\)。考虑构造取到 \(1\) 的下界。 观察到,\(\text{LCS}\le1\) 等价于去掉两序列都不存在的数后,两序列完全相反。于是有: 在 \(\{x\},\{y\}\) 后增加两序列都不存在的数,不影响 LCS。 进行 阅读全文
posted @ 2024-10-15 14:51 liangbowen 阅读(58) 评论(0) 推荐(0)
摘要: acam 作为多模匹配算法,很多东西与 kmp 相同,另外增添了 fail 树上操作的关键性质。 朴素 acam 就是 trie 树,fail 指针就是在当前 node 找一个后缀,使得在其他串存在一个前缀是这个后缀(类似 kmp)。 trie 图,就是简单优化了这个"树上乱跳"的过程,补全每个节点 阅读全文
posted @ 2024-09-28 16:57 liangbowen 阅读(69) 评论(0) 推荐(0)
摘要: 一个启发是,对于一个 \(i\) 的两个转移 \(j,k\),比较 \(j\) 与 \(k\) 的转移优劣。 可以用斜率优化的场景:对比后可以分拆出 \(slope(j,k)\le\texttt{只和i相关的一些东西}\) 的形式。 例如 P3195,首先写出转移方程 \(dp_i=\min\lim 阅读全文
posted @ 2024-09-28 16:46 liangbowen 阅读(61) 评论(0) 推荐(0)
摘要: blog。算是单杀 * 2800 了(虽然做过 [HNOI2012] 集合选数)。来写一个题解区复杂度最劣做法。 思路 考虑很多元素是可以分开处理的。例如 \(\{1,2,3,4,6,9,\cdots\}\) 需要一起处理,而 \(5,10\) 等数并不会影响到这个集合。 对于每一个集合,考虑构造如 阅读全文
posted @ 2024-09-25 22:08 liangbowen 阅读(88) 评论(0) 推荐(0)
摘要: 初赛 上午 J。这也太简单了,30min 不到搞定。趴下来然后发现根本不困,遂发呆。 后面默写了 \(1\sim400\) 的自然数,然后手算了一下 \(2^63\)。 一对答案 97。?这都 AK 不了我重开吧。 原来是不会判断质数了。来生一定这样判质数: bool isprime(int n) 阅读全文
posted @ 2024-09-21 22:45 liangbowen 阅读(51) 评论(0) 推荐(0)
摘要: blog。获得题解区最劣复杂度做法( 对于这种三元环(?)的样子的题,直接考虑根号分治。 考虑枚举 \((a,b)\),假设 \(u=a,v=b\) 的三元组有 \(S\) 个,根号分治: \(S\le B\),暴力从 \(S\) 个里面选两个作为 \(c,d\),暴力检验,\(O(S^2)\)。 阅读全文
posted @ 2024-09-21 22:19 liangbowen 阅读(52) 评论(0) 推荐(0)
摘要: qwq。 KMP 是由三个传奇特级生物 Kangaroo、Monkey、Pig 共同发明的算法,她非常聪明,以至于我今天才真正知道他在干什么。 引入 袋鼠猴子小猪 可以线性解决下面的问题: 给定猴子串 \(S\) 与模式串 \(T\),在 \(S\) 中找到所有与 \(T\) 完全相同的子串。 no 阅读全文
posted @ 2024-08-26 14:42 liangbowen 阅读(112) 评论(0) 推荐(0)
摘要: blog。这玩意有空心橙????写篇题解祭一下速杀 *2400( 什么时候,两个串可能会冲突?答案是他们有公共最小循环节。于是用 KMP 求出每个串的最小循环节。 存在一个暴力:将所有最小循环节相同的串放到一起 query,对于一个循环节长度为 \(r\) 的串,遍历 \(r,2r,3r,\cdot 阅读全文
posted @ 2024-08-26 13:04 liangbowen 阅读(59) 评论(0) 推荐(0)
摘要: blog。写一个题解区没有的蠢做法,不依赖 dp 但是很难转到 Hard Version( 对于已经确定的序列,深度有单调性。就是如果答案为 \(x\),那么肯定能选出深度为 \(1\sim x\) 的子序列。 记 \(\operatorname{check}_s(x)\) 表示 check 序列 阅读全文
posted @ 2024-08-21 16:00 liangbowen 阅读(43) 评论(0) 推荐(0)
摘要: 傻逼题 给一张无向简单连通图,给每一条边定向,使得每一个点出度为偶数,输出任意一种方案或判无解。 \(n,m\le 10^5\)。 $ $ $ $ $ $ $ $ $ $ 先随便定向然后调整。记 degree 偶数的点为 BananaNode,奇数的为 MonkeyNode,目标是使所有点都为 Ba 阅读全文
posted @ 2024-08-19 08:24 liangbowen 阅读(129) 评论(2) 推荐(0)
上一页 1 2 3 4 5 6 7 8 ··· 19 下一页